Loading...
Searching...
No Matches
gtsam::GaussianFactor Class Referenceabstract

## Detailed Description

An abstract virtual base class for JacobianFactor and HessianFactor.

A GaussianFactor has a quadratic error function. GaussianFactor is non-mutable (all methods const!). The factor value is exp(-0.5*||Ax-b||^2)

Inheritance diagram for gtsam::GaussianFactor:

## Public Member Functions

| GaussianFactor ()
| Default constructor creates empty factor.
template<typename CONTAINER>
| GaussianFactor (const CONTAINER &keys)
| Construct from container of keys.
virtual | ~GaussianFactor ()
| Destructor.
void | print (const std::string &s="", const KeyFormatter &formatter=DefaultKeyFormatter) const override=0
| print
virtual bool | equals (const GaussianFactor &lf, double tol=1e-9) const =0
| Equals for testable.
virtual double | error (const VectorValues &c) const
double | error (const HybridValues &c) const override
| All factor types need to implement an error function.
virtual DenseIndex | getDim (const_iterator variable) const =0
| Return the dimension of the variable pointed to by the given key iterator.
virtual Matrix | augmentedJacobian () const =0
| Return a dense \( [ \;A\;b\; ] \in \mathbb{R}^{m \times n+1} \) Jacobian matrix, augmented with b with the noise models baked into A and b.
virtual std::pair< Matrix, Vector > | jacobian () const =0
| Return the dense Jacobian \( A \) and right-hand-side \( b \), with the noise models baked into A and b.
virtual Matrix | augmentedInformation () const =0
| Return the augmented information matrix represented by this GaussianFactor.
virtual Matrix | information () const =0
| Return the non-augmented information matrix represented by this GaussianFactor.
VectorValues | hessianDiagonal () const
| Return the diagonal of the Hessian for this factor.
virtual void | hessianDiagonalAdd (VectorValues &d) const =0
| Add the current diagonal to a VectorValues instance.
virtual void | hessianDiagonal (double *d) const =0
| Raw memory access version of hessianDiagonal.
virtual std::map< Key, Matrix > | hessianBlockDiagonal () const =0
| Return the block diagonal of the Hessian for this factor.
virtual GaussianFactor::shared_ptr | clone () const =0
| Clone a factor (make a deep copy).
virtual GaussianFactor::shared_ptr | negate () const =0
| Construct the corresponding anti-factor to negate information stored stored in this factor.
virtual void | updateHessian (const KeyVector &keys, SymmetricBlockMatrix *info) const =0
| Update an information matrix by adding the information corresponding to this factor (used internally during elimination).
virtual void | multiplyHessianAdd (double alpha, const VectorValues &x, VectorValues &y) const =0
| y += alpha * A'*A*x
virtual VectorValues | gradientAtZero () const =0
| A'*b for Jacobian, eta for Hessian.
virtual void | gradientAtZero (double *d) const =0
| Raw memory access version of gradientAtZero.
virtual Vector | gradient (Key key, const VectorValues &x) const =0
| Gradient wrt a key at any values.
Public Member Functions inherited from gtsam::Factor
virtual | ~Factor ()=default
| Default destructor.
bool | empty () const
| Whether the factor is empty (involves zero variables).
Key | front () const
| First key.
Key | back () const
| Last key.
const_iterator | find (Key key) const
| find
const KeyVector & | keys () const
| Access the factor's involved variable keys.
const_iterator | begin () const
| Iterator at beginning of involved variable keys.
const_iterator | end () const
| Iterator at end of involved variable keys.
size_t | size () const
virtual void | printKeys (const std::string &s="Factor", const KeyFormatter &formatter=DefaultKeyFormatter) const
| print only keys
bool | equals (const This &other, double tol=1e-9) const
| check equality
KeyVector & | keys ()
iterator | begin ()
| Iterator at beginning of involved variable keys.
iterator | end ()
| Iterator at end of involved variable keys.

## Static Public Member Functions

template<typename CONTAINER>
static DenseIndex | Slot (const CONTAINER &keys, Key key)

## Public Types

typedef GaussianFactor | This
| This class.
typedef boost::shared_ptr< This > | shared_ptr
| shared_ptr to this class
typedef Factor | Base
| Our base class.
Public Types inherited from gtsam::Factor
typedef KeyVector::iterator | iterator
| Iterator over keys.
typedef KeyVector::const_iterator | const_iterator
| Const iterator over keys.

## Friends

class | boost::serialization::access
| Serialization function.

## Additional Inherited Members

| Factor ()
| Default constructor for I/O.
template<typename CONTAINER>
| Factor (const CONTAINER &keys)
| Construct factor from container of keys.
template<typename ITERATOR>
| Factor (ITERATOR first, ITERATOR last)
| Construct factor from iterator keys.
template<typename CONTAINER>
static Factor | FromKeys (const CONTAINER &keys)
| Construct factor from container of keys.
template<typename ITERATOR>
static Factor | FromIterators (ITERATOR first, ITERATOR last)
| Construct factor from iterator keys.
Protected Attributes inherited from gtsam::Factor
KeyVector | keys_
| The keys involved in this factor.

## Constructor & Destructor Documentation

## GaussianFactor()

template<typename CONTAINER>

gtsam::GaussianFactor::GaussianFactor | ( | const CONTAINER & | keys | ) |

inline

Construct from container of keys.

This constructor is used internally from derived factor constructors, either from a container of keys or from a boost::assign::list_of.

## Member Function Documentation

## augmentedInformation()

virtual Matrix gtsam::GaussianFactor::augmentedInformation | ( |  | ) | const

pure virtual

Return the augmented information matrix represented by this GaussianFactor.

The augmented information matrix contains the information matrix with an additional column holding the information vector, and an additional row holding the transpose of the information vector. The lower-right entry contains the constant error term (when \( \delta x = 0 \)). The augmented information matrix is described in more detail in HessianFactor, which in fact stores an augmented information matrix.

Implemented in gtsam::HessianFactor, gtsam::JacobianFactor, and gtsam::RegularImplicitSchurFactor< CAMERA >.

## augmentedJacobian()

virtual Matrix gtsam::GaussianFactor::augmentedJacobian | ( |  | ) | const

pure virtual

Return a dense \( [ \;A\;b\; ] \in \mathbb{R}^{m \times n+1} \) Jacobian matrix, augmented with b with the noise models baked into A and b.

The negative log-likelihood is \( \frac{1}{2} \Vert Ax-b \Vert^2 \). See also GaussianFactorGraph::jacobian and GaussianFactorGraph::sparseJacobian.

Implemented in gtsam::HessianFactor, gtsam::JacobianFactor, and gtsam::RegularImplicitSchurFactor< CAMERA >.

## clone()

virtual GaussianFactor::shared_ptr gtsam::GaussianFactor::clone | ( |  | ) | const

pure virtual

Clone a factor (make a deep copy).

Implemented in gtsam::HessianFactor, gtsam::JacobianFactor, and gtsam::RegularImplicitSchurFactor< CAMERA >.

## equals()

virtual bool gtsam::GaussianFactor::equals | ( | const GaussianFactor & | lf,
|  | double | tol = 1e-9 ) const

pure virtual

Equals for testable.

Implemented in gtsam::GaussianConditional, gtsam::HessianFactor, gtsam::JacobianFactor, and gtsam::RegularImplicitSchurFactor< CAMERA >.

## error() [1/2]

double GaussianFactor::error | ( | const HybridValues & | c | ) | const

override virtual

All factor types need to implement an error function.

In factor graphs, this is the negative log-likelihood.

Reimplemented from gtsam::Factor.

Reimplemented in gtsam::HessianFactor, and gtsam::JacobianFactor.

## error() [2/2]

double GaussianFactor::error | ( | const VectorValues & | c | ) | const

virtual

Reimplemented in gtsam::HessianFactor.

## getDim()

virtual DenseIndex gtsam::GaussianFactor::getDim | ( | const_iterator | variable | ) | const

pure virtual

Return the dimension of the variable pointed to by the given key iterator.

Implemented in gtsam::HessianFactor, gtsam::JacobianFactor, and gtsam::RegularImplicitSchurFactor< CAMERA >.

## gradient()

virtual Vector gtsam::GaussianFactor::gradient | ( | Key | key,
|  | const VectorValues & | x ) const

pure virtual

Gradient wrt a key at any values.

Implemented in gtsam::HessianFactor, gtsam::JacobianFactor, and gtsam::RegularImplicitSchurFactor< CAMERA >.

## gradientAtZero() [1/2]

virtual VectorValues gtsam::GaussianFactor::gradientAtZero | ( |  | ) | const

pure virtual

A'*b for Jacobian, eta for Hessian.

Implemented in gtsam::HessianFactor, gtsam::JacobianFactor, gtsam::RegularImplicitSchurFactor< CAMERA >, and gtsam::RegularJacobianFactor< D >.

## gradientAtZero() [2/2]

virtual void gtsam::GaussianFactor::gradientAtZero | ( | double * | d | ) | const

pure virtual

Raw memory access version of gradientAtZero.

Implemented in gtsam::HessianFactor, gtsam::JacobianFactor, gtsam::RegularHessianFactor< D >, gtsam::RegularImplicitSchurFactor< CAMERA >, and gtsam::RegularJacobianFactor< D >.

## hessianBlockDiagonal()

virtual std::map< Key, Matrix > gtsam::GaussianFactor::hessianBlockDiagonal | ( |  | ) | const

pure virtual

Return the block diagonal of the Hessian for this factor.

Implemented in gtsam::HessianFactor, gtsam::JacobianFactor, and gtsam::RegularImplicitSchurFactor< CAMERA >.

## hessianDiagonal()

virtual void gtsam::GaussianFactor::hessianDiagonal | ( | double * | d | ) | const

pure virtual

Raw memory access version of hessianDiagonal.

Implemented in gtsam::HessianFactor, gtsam::JacobianFactor, gtsam::RegularHessianFactor< D >, gtsam::RegularImplicitSchurFactor< CAMERA >, and gtsam::RegularJacobianFactor< D >.

## hessianDiagonalAdd()

virtual void gtsam::GaussianFactor::hessianDiagonalAdd | ( | VectorValues & | d | ) | const

pure virtual

Add the current diagonal to a VectorValues instance.

Implemented in gtsam::HessianFactor, gtsam::JacobianFactor, and gtsam::RegularImplicitSchurFactor< CAMERA >.

## information()

virtual Matrix gtsam::GaussianFactor::information | ( |  | ) | const

pure virtual

Return the non-augmented information matrix represented by this GaussianFactor.

Implemented in gtsam::HessianFactor, gtsam::JacobianFactor, and gtsam::RegularImplicitSchurFactor< CAMERA >.

## jacobian()

virtual std::pair< Matrix, Vector > gtsam::GaussianFactor::jacobian | ( |  | ) | const

pure virtual

Return the dense Jacobian \( A \) and right-hand-side \( b \), with the noise models baked into A and b.

The negative log-likelihood is \( \frac{1}{2} \Vert Ax-b \Vert^2 \). See also GaussianFactorGraph::augmentedJacobian and GaussianFactorGraph::sparseJacobian.

Implemented in gtsam::HessianFactor, gtsam::JacobianFactor, and gtsam::RegularImplicitSchurFactor< CAMERA >.

## multiplyHessianAdd()

virtual void gtsam::GaussianFactor::multiplyHessianAdd | ( | double | alpha,
|  | const VectorValues & | x,
|  | VectorValues & | y ) const

pure virtual

y += alpha * A'*A*x

Implemented in gtsam::HessianFactor, gtsam::JacobianFactor, gtsam::RegularHessianFactor< D >, gtsam::RegularImplicitSchurFactor< CAMERA >, and gtsam::RegularJacobianFactor< D >.

## negate()

virtual GaussianFactor::shared_ptr gtsam::GaussianFactor::negate | ( |  | ) | const

pure virtual

Construct the corresponding anti-factor to negate information stored stored in this factor.

Returns
  a HessianFactor with negated Hessian matrices

Implemented in gtsam::HessianFactor, gtsam::JacobianFactor, and gtsam::RegularImplicitSchurFactor< CAMERA >.

## print()

void gtsam::GaussianFactor::print | ( | const std::string & | s = "",
|  | const KeyFormatter & | formatter = DefaultKeyFormatter ) const

override pure virtual

print

Reimplemented from gtsam::Factor.

Implemented in gtsam::GaussianConditional, gtsam::GaussianDensity, gtsam::HessianFactor, gtsam::JacobianFactor, and gtsam::RegularImplicitSchurFactor< CAMERA >.

## updateHessian()

virtual void gtsam::GaussianFactor::updateHessian | ( | const KeyVector & | keys,
|  | SymmetricBlockMatrix * | info ) const

pure virtual

Update an information matrix by adding the information corresponding to this factor (used internally during elimination).

Parameters

  scatter | A mapping from variable index to slot index in this HessianFactor
  info | The information matrix to be updated

Implemented in gtsam::BinaryJacobianFactor< M, N1, N2 >, gtsam::HessianFactor, gtsam::JacobianFactor, and gtsam::RegularImplicitSchurFactor< CAMERA >.

The documentation for this class was generated from the following files:

- /build/gtsam-gchP9J/gtsam-4.2.2+dfsg/gtsam/linear/GaussianFactor.h
- /build/gtsam-gchP9J/gtsam-4.2.2+dfsg/gtsam/linear/GaussianFactor.cpp